(function() {
    'use strict';

    angular
        .module('app.auth', [])

    //Login
    .controller('LoginCtrl', function($scope, $rootScope, Event, $state, $ionicHistory, AuthService, ngNotify, $window) {
        $scope.loginData = {};

        $scope.submit = function(isValid) {
            if (isValid) {
                var email = $scope.loginData.email;
                var password = $scope.loginData.password;

                AuthService.loginUser(email, password).then(function(retval) {
                    console.log(retval);

                    if (retval.status) {
                        $rootScope.user = firebase.auth().currentUser;
                        console.log($rootScope.user);

                        $ionicHistory.clearCache();
                        $ionicHistory.clearHistory();
                        $ionicHistory.nextViewOptions({
                            disableBack: true,
                            historyRoot: true
                        });
                        $state.go('app.home');

                        ngNotify.set('Login succeed!', 'success');
                    } else {
                        ngNotify.set('Login failed: ' + retval.message, 'error');
                    }
                });

            };
        };
    })

    //Login
    .controller('LogoutCtrl', function($scope, Event, $state, $ionicHistory, AuthService, ngNotify) {


    })

    //Create Account
    .controller('CreateAccountCtrl', function($scope, $state, AuthService, ngNotify) {
        $scope.submitData = {};

        $scope.submit = function(isValid) {
            if (isValid) {
                var fullName = $scope.submitData.fullName;
                var email = $scope.submitData.email;
                var password = $scope.submitData.password;
                var confirmPassword = $scope.submitData.confirmPassword;

                if (password != confirmPassword) {
                    ngNotify.set('Your password did not match!', 'error');
                } else {
                    AuthService.signupEmail(email, password, fullName).then(function(retval) {
                        if (retval.status) {
                            $state.go("app.login");
                            ngNotify.set('Check your inbox to verify your email and then login here', 'success');
                        } else {
                            ngNotify.set(retval.message, 'error');
                        }
                    });
                }
            }
        }
    })

    //Forgot password
    .controller('ForgotCtrl', function($scope, $state, AuthService, ngNotify) {
        $scope.submitData = {};

        $scope.submit = function(isValid) {
            var email = $scope.submitData.email;

            AuthService.resetPassword(email).then(function(retval) {
                console.log(retval);

                if (retval.status) {
                    $state.go("app.login");
                    ngNotify.set(retval.message, 'success');
                } else {
                    ngNotify.set(retval.message, 'error');
                }
            });
        }
    });

})();