angular.module('app.events', [])

//Talk:
.controller('TalkCtrl', function($scope, $state, $window, Event, $stateParams, ngNotify) {

    // Scope properties
    $scope.mySchedule = null;
    $scope.processing = true;
    $scope.talk = null;
    $scope.speakers = null;
    $scope.uid = null;

    // Check login state
    firebase.auth().onAuthStateChanged(function(firebaseUser) {
        if (firebaseUser) {
            $scope.uid = firebaseUser.uid;
            Event.getMySchedule($scope.uid).then(function(response){
                $scope.mySchedule = response;
            });
        }
    });

    //add event to my schedule
    $scope.toggleMySchedule = function(talk) {
        if ($scope.uid) {
            Event.toggleMySchedule(talk, $scope.uid);
        } else {
            $state.transitionTo("app.login");
            event.preventDefault();
            ngNotify.set('You have to login to access this feature', 'error');
        }

        Event.getMySchedule($scope.uid).then(function(response){
            $scope.mySchedule = response;
        });
    }

    $scope.openLink = function(url) {
        window.open(url, '_blank', 'location=yes');
        return false;
    }

    Event.fetchCategories().then(function() {
        Event.fetchTalkInfo(parseInt($stateParams.talkId))
            .then(function successCallback(response) {
                // this callback will be called asynchronously
                // when the response is available
                $scope.talk = response;
                console.log(response);

                Event.fetchSpeakersById(response.speakers).then(function(response) {
                    $scope.processing = false;
                    $scope.speakers = response;
                })

                // var talkInfo = response.data;
                // var talkSpeakers = talkInfo.acf.related_page;

                // $scope.talk = {
                //   id: talkInfo.id,
                //   title: talkInfo.title.rendered,
                //   date: talkInfo.date,
                //   location: talkInfo.acf.venue + talkInfo.acf.address
                // };

                // $scope.speakers = [];
                // for (var i = 0; i < speakerTalks.length; i++) {
                //   var talk = speakerTalks[i];
                //   $scope.speakers.push({
                //     id: talk.ID,
                //     title: talk.post_title,
                //     fDate: moment(talk.post_date).format("h:mm A, dddd, MMM Do")
                //   });
                // }
            }, function errorCallback(response) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                $scope.processing = false;
                console.log(response);
            });
    });
});